#line 1 "C:/Users/Nart Schinackow/Desktop/MikrommbTest/Source_Code/mikroC PRO for PIC/Source_events_code.c"
#line 1 "c:/users/nart schinackow/desktop/mikrommbtest/source_code/mikroc pro for pic/source_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef const code struct CScreen TCScreen;
typedef struct MyScreen TMyScreen;

typedef const struct CLabel {
 unsigned int OwnerScreenID;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCLabel;

typedef struct Image {
 unsigned int OwnerScreenID;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Picture_Name;
 char Visible;
 char Active;
 char Picture_Type;
 char Picture_Ratio;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TImage;

typedef const struct CBox {
 unsigned int OwnerScreenID;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCBox;

typedef struct ProgressBar {
 unsigned int OwnerScreenID;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 unsigned int Background_Color;
 unsigned int Min;
 unsigned int Max;
 unsigned int Position;
 char Show_Position;
 char Show_Percentage;
 char Smooth;
 char Rounded;
 char Corner_Radius;
} TProgressBar;

 struct CScreen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned short ObjectsCount;
 unsigned int CLabelsCount;
 TCLabel * const code *CLabels;
 unsigned int ImagesCount;
 TImage * const code *Images;
 unsigned int CBoxesCount;
 TCBox * const code *CBoxes;
 unsigned int ProgressBarsCount;
 TProgressBar * const code *ProgressBars;
};

struct MyScreen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned short ObjectsCount;
 unsigned int CLabelsCount;
 TCLabel * const code *CLabels;
 unsigned int ImagesCount;
 TImage * const code *Images;
 unsigned int CBoxesCount;
 TCBox * const code *CBoxes;
 unsigned int ProgressBarsCount;
 TProgressBar * const code *ProgressBars;
};

extern const MainScreenScreenID;
extern const ControlsScreenScreenID;

extern TCScreen * const code CScreens[2];
extern TCScreen MainScreen;
extern TCBox Box1;
extern TProgressBar MainPageProgress;
extern TCLabel LoadingLabel;
extern TCLabel * const code Screen1_CLabels[1];
extern TCBox * const code Screen1_CBoxes[1];
extern TProgressBar * const code Screen1_ProgressBars[1];


extern TCScreen ControlsScreen;
extern TCBox Box2;
extern TImage Led1;
extern TImage Led4;
extern TImage Switch3;
extern TImage Switch2;
extern TImage Led3;
extern TImage Switch1;
extern TImage Switch4;
extern TImage Led2;
extern TProgressBar ProgressBar1;
extern TImage * const code Screen2_Images[8];
extern TCBox * const code Screen2_CBoxes[1];
extern TProgressBar * const code Screen2_ProgressBars[1];


extern TMyScreen CurrentMyScreen;



void Led1OnClick();
void Led2OnClick();
void Led3OnClick();
void Led4OnClick();
void Switch1OnClick();
void Switch2OnClick();
void Switch3OnClick();
void Switch4OnClick();




extern const char Box1_Caption[];
extern char MainPageProgress_Caption[];
extern const char LoadingLabel_Caption[];
extern const char Box2_Caption[];
extern char Led1_Caption[];
extern char Led4_Caption[];
extern char Switch3_Caption[];
extern char Switch2_Caption[];
extern char Led3_Caption[];
extern char Switch1_Caption[];
extern char Switch4_Caption[];
extern char Led2_Caption[];
extern char ProgressBar1_Caption[];


void DrawScreen(unsigned int aScreenID);
void DrawCLabel(TCLabel *AClabel);
void DrawImage(TImage *AImage);
void DrawCBox(TCBox *ACbox);
void DrawProgressBar(TProgressBar *AProgressBar);
void UpdatePBPosition(TProgressBar *AProgressBar);
void Check_TP();
void Start_TP();
#line 1 "c:/users/nart schinackow/desktop/mikrommbtest/source_code/mikroc pro for pic/source_resources.h"
#line 1 "c:/users/nart schinackow/desktop/mikrommbtest/source_code/mikroc pro for pic/switchesandleds.h"
struct SWITCHES_TYPE
{
 char VerticalToggleSwitch;
 char HorizontalToggleSwitch;
 char PushButtonSwitch;
 char VerticalRockerSwitch;
 char HorizontalRockerSwitch;
 char VerticalSlideSwitch;
 char HorizontalSlideSwitch;
 char RoundHorizonalSlideSwitch;
 char RoundVerticalSlideSwitch;
 char RoundVirticalToggleSwitch;
 char RoundHorizontalToggleSwitch;
 char RoundPushButtonSwitch;
 char RoundVerticalRockerSwitch;
 char RoundHorizontalRockerSwitch;
}SwitchType={0,1,2,3,4,5,6,7,8,9,10,11,12,13};

struct LEDS_TYPE
{
 char RoundedLed;
 char SquareLed;
}LedType={0,1};




void __CHANGE_LED_VALUE(TImage* ImageBox, char State, char Led_Type)
{
 switch(Led_Type)
 {
 case 0:
 if(State==1){ImageBox->Picture_Name= 0x0000B61C ;DrawImage(ImageBox);}
 else {ImageBox->Picture_Name= 0x00001FFE ;DrawImage(ImageBox);}
 break;
 case 1:
 if(State==1){ImageBox->Picture_Name= 0x0000F228 ;DrawImage(ImageBox);}
 else {ImageBox->Picture_Name= 0x0000D422 ;DrawImage(ImageBox);}
 break;
 }
}
char __IS_LED_ON(TImage* ImageBox)
{
 return ((unsigned long)ImageBox->Picture_Name== 0x0000B61C ||(unsigned long)ImageBox->Picture_Name== 0x0000F228 );
}
char __IS_LED_OFF(TImage* ImageBox)
{
 return !((unsigned long)ImageBox->Picture_Name== 0x0000B61C ||(unsigned long)ImageBox->Picture_Name== 0x0000F228 );
}


void __CHANGE_SWITCH_VALUE(TImage* ImageBox, char State, char Switch_Type)
{
 switch(Switch_Type)
 {
 case 0:
 if(state==1){ImageBox->Picture_Name= 0x0001102E ;DrawImage(ImageBox);}
 else{ImageBox->Picture_Name= 0x00007A10 ;DrawImage(ImageBox);}
 break;
 case 1:
 if(state==1){ImageBox->Picture_Name= 0x0001C452 ;DrawImage(ImageBox);}
 else{ImageBox->Picture_Name= 0x0001A64C ;DrawImage(ImageBox);}
 break;
 case 2:
 if(state==1){ImageBox->Picture_Name= 0x00021E64 ;DrawImage(ImageBox);}
 else{ImageBox->Picture_Name= 0x00009816 ;DrawImage(ImageBox);}
 break;
 case 3:
 if(state==1){ImageBox->Picture_Name= 0x00025A70 ;DrawImage(ImageBox);}
 else{ImageBox->Picture_Name= 0x00023C6A ;DrawImage(ImageBox);}
 break;
 case 4:
 if(state==1){ImageBox->Picture_Name= 0x00012E34 ;DrawImage(ImageBox);}
 else{ImageBox->Picture_Name= 0x00005C0A ;DrawImage(ImageBox);}
 break;
 case 5:
 if(state==1){ImageBox->Picture_Name= 0x00030E94 ;DrawImage(ImageBox);}
 else{ImageBox->Picture_Name= 0x0002F08E ;DrawImage(ImageBox);}
 break;
 case 6:
 if(state==1){ImageBox->Picture_Name= 0x00014C3A ;DrawImage(ImageBox);}
 else{ImageBox->Picture_Name= 0x00003E04 ;DrawImage(ImageBox);}
 break;
 case 7:
 if(state==1){ImageBox->Picture_Name= 0x00018846 ;DrawImage(ImageBox);}
 else{ImageBox->Picture_Name= 0x00016A40 ;DrawImage(ImageBox);}
 break;
 case 8:
 if(state==1){ImageBox->Picture_Name= 0x0002005E ;DrawImage(ImageBox);}
 else{ImageBox->Picture_Name= 0x0001E258 ;DrawImage(ImageBox);}
 break;
 case 9:
 if(state==1){ImageBox->Picture_Name= 0x0002967C ;DrawImage(ImageBox);}
 else{ImageBox->Picture_Name= 0x00027876 ;DrawImage(ImageBox);}
 break;
 case 10:
 if(state==1){ImageBox->Picture_Name= 0x0002D288 ;DrawImage(ImageBox);}
 else{ImageBox->Picture_Name= 0x0002B482 ;DrawImage(ImageBox);}
 break;
 case 11:
 if(state==1){ImageBox->Picture_Name= 0x0003C2B8 ;DrawImage(ImageBox);}
 else{ImageBox->Picture_Name= 0x0003A4B2 ;DrawImage(ImageBox);}
 break;
 case 12:
 if(state==1){ImageBox->Picture_Name= 0x00034AA0 ;DrawImage(ImageBox);}
 else{ImageBox->Picture_Name= 0x00032C9A ;DrawImage(ImageBox);}
 break;
 case 13:
 if(state==1){ImageBox->Picture_Name= 0x00034AA0 ;DrawImage(ImageBox);}
 else{ImageBox->Picture_Name= 0x00032C9A ;DrawImage(ImageBox);}
 break;
 }
}





struct _LED_CONTROL
{
 void (*Value)(TImage* ImageBox, char State, char Led_Type);
 char (*IsOn)(TImage* ImageBox);
 char (*IsOff)(TImage* ImageBox);
}Led={
&__CHANGE_LED_VALUE,
&__IS_LED_ON,
&__IS_LED_OFF};

struct _SWITCH_CONTROL
{
 void (*Value)(TImage* ImageBox, char State, char Switch_Type);

}Switch={& __CHANGE_SWITCH_VALUE};
#line 13 "C:/Users/Nart Schinackow/Desktop/MikrommbTest/Source_Code/mikroC PRO for PIC/Source_events_code.c"
char Percentage=0;

void Perform_Loading()
{
 char i;
 for(i=0;i<100;i++)
 {
 MainPageProgress.Position=i;
 DrawProgressBar(&MainPageProgress);
 }
}

void Led1OnClick() {

}

void Led2OnClick() {

}

void Led3OnClick() {

}

void Led4OnClick() {

}

void Switch1OnClick() {
Switch.Value(&Switch1,1,SwitchType.RoundPushButtonSwitch);
delay_ms(100);
Switch.Value(&Switch1,0,SwitchType.RoundPushButtonSwitch);
delay_ms(100);
if(Led.IsOn(&Led1))Led.Value(&Led1,0,LedType.RoundedLed);
else Led.Value(&Led1,1,LedType.RoundedLed);
}

void Switch2OnClick(){
Switch.Value(&Switch2,1,SwitchType.HorizontalToggleSwitch);
delay_ms(100);
Switch.Value(&Switch2,0,SwitchType.HorizontalToggleSwitch);
delay_ms(100);
if(Led.IsOn(&Led2))Led.Value(&Led2,0,LedType.RoundedLed);
else Led.Value(&Led2,1,LedType.RoundedLed);
}

void Switch3OnClick() {
Switch.Value(&Switch3,1,SwitchType.VerticalSlideSwitch);
delay_ms(100);
Switch.Value(&Switch3,0,SwitchType.VerticalSlideSwitch);
delay_ms(100);
if(Led.IsOn(&Led3))Led.Value(&Led3,0,LedType.RoundedLed);
else Led.Value(&Led3,1,LedType.RoundedLed);
}

void Switch4OnClick() {
Switch.Value(&Switch4,1,SwitchType.RoundVirticalToggleSwitch);
delay_ms(100);
Switch.Value(&Switch4,0,SwitchType.RoundVirticalToggleSwitch);
delay_ms(100);
if(Led.IsOn(&Led4))Led.Value(&Led4,0,LedType.RoundedLed);
else Led.Value(&Led4,1,LedType.RoundedLed);
}
